<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on June 25, 2009 at 7:09:50 pm</time-stamp>
<!-- Changes from: PV-Datachannel(Green.326,srobin)  to: PV-Datachannel(Green.327,bbuxton) -->


<methods>
<class-id>Core.Object</class-id> <category>PROVISO</category>

<body package="PV-Base Extensions" selector="owner:">owner: aParent

	"do nothing"</body>
</methods>



<methods>
<class-id>PROVISO.PvSubelement</class-id> <category>accessing-relationships</category>

<body package="PV-DM-Support" selector="relations:">relations: anObject
	
	relations := anObject.
	relations ifNotNil: [relations whileMutableDo: [relations owner: self]]</body>
</methods>

<methods>
<class-id>PROVISO.PvSubelement</class-id> <category>copying</category>

<body package="PV-DM-Support" selector="postCopy">postCopy
	
	super postCopy.
	properties notNil 
		ifTrue: 
			[properties := 
				properties copy
					owner: self;
					yourself].
	relations notNil 
		ifTrue: 
			[relations := 
				relations copy
					owner: self;
					yourself]</body>
</methods>

<methods>
<class-id>PROVISO.PvSubelement</class-id> <category>serilization</category>

<body package="PV-DM-Support" selector="repositoryReadFrom:">repositoryReadFrom: strm 
	
	super repositoryReadFrom: strm.
	(invariant := String readNetStringFrom: strm) = 'nil' 
		ifTrue: [invariant := nil].
	(origin := (String readNetStringFrom: strm) asSymbol) = #nil 
		ifTrue: [origin := nil].
	(username := (String readNetStringFrom: strm) asSymbol) = #nil 
		ifTrue: [username := nil].
	(instance := String readNetStringFrom: strm) = 'nil' 
		ifTrue: [instance := nil].
	(familyString := (String readNetStringFrom: strm) asSymbol) = #nil 
		ifTrue: [familyString := nil].
	(Integer readNetStringFrom: strm) timesRepeat: 
		[| key value |
		key := Integer readNetStringFrom: strm.
		value := PvDomainObject repositoryReadFrom: strm.
		self properties at: key put: value].
	relations ifNil: 
		[relations := 
			(PvIdentityDictionary new: 2)
				owner: self;
				yourself].
	(Integer readNetStringFrom: strm) timesRepeat: 
		[| key value |
		key := Integer readNetStringFrom: strm.
		value := PvDomainObject repositoryReadFrom: strm.
		self relations at: key put: value]</body>
</methods>

<methods>
<class-id>PROVISO.PvSubelement</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="properties:">properties: anObject

	properties := anObject.
	properties ifNotNil: [properties whileMutableDo: [properties owner: self]]</body>
</methods>


<methods>
<class-id>PROVISO.PvElement</class-id> <category>accessing</category>

<body package="PV-DM-Support" selector="properties:">properties: anObject

	properties := anObject.
	properties ifNotNil: [properties whileMutableDo: [properties owner: self]]</body>

<body package="PV-DM-Support" selector="properties">properties

	properties isNil ifTrue: 
		[self properties: (PvIdentityDictionary new: 16)].
	^properties</body>
</methods>



<methods>
<class-id>PROVISO.UBA.PvAggregator</class-id> <category>control</category>

<body package="NGUBA-Application" selector="defaultOnEndOfPeriod">defaultOnEndOfPeriod
	
	self executeWithWriteControl: 
		[self collection keysAndValuesDo: 
			[:key :state | 
			self closePeriodFunction 
				valueWithThis: self
				with: state]]</body>
</methods>

<methods>
<class-id>PROVISO.UBA.PvAggregator</class-id> <category>processing</category>

<body package="NGUBA-Application" selector="executeWithWriteControl:">executeWithWriteControl: aBlock 
	
	^self root 
		ifNil: aBlock
		ifNotNil: 
			[:myRoot | 
			myRoot == self 
				ifTrue: [aBlock value]
				ifFalse: [myRoot executeWithWriteControl: aBlock]]</body>

<body package="NGUBA-Application" selector="handleNormalTuple:">handleNormalTuple: aTuple 
	
	self executeWithWriteControl: 
		[| key state |
		key := 
			self keyFunction 
				valueWithThis: self
				with: aTuple.
		key isSmeeString 
			ifTrue: [key := key smeeToPrimitiveString].
		key isSmeeNumber 
			ifTrue: [key := key smeeToNumber].
		state := 
			self 
				getStateFor: key
				with: aTuple.
		self calculateFunction 
			valueWithThis: self
			with: key
			with: state
			with: aTuple]</body>
</methods>



</st-source>
